/* Generated by generate-js-builtins do not hand edit. */

/*
 * Copyright (C) 2015 Yusuke Suzuki <utatane.tea@gmail.com>.
 * Copyright (C) 2014 Apple Inc. All rights reserved.
 * Copyright (C) 2014, 2015 Apple Inc. All rights reserved.
 * Copyright (C) 2015 Apple Inc. All rights reserved.
 * Copyright (C) 2015 Jordan Harband. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE INC. OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */



#ifndef JSCBuiltins_H
#define JSCBuiltins_H

#include "ConstructAbility.h"

namespace JSC {

class FunctionExecutable;
class Identifier;
class JSGlobalObject;
class SourceCode;
class UnlinkedFunctionExecutable;
class VM;

FunctionExecutable* createBuiltinExecutable(VM&, UnlinkedFunctionExecutable*, const SourceCode&);

/* Array.prototype functions */
extern const char* s_arrayPrototypeReduceCode;
extern const int s_arrayPrototypeReduceCodeLength;
extern const ConstructAbility s_arrayPrototypeReduceCodeConstructAbility;
extern const char* s_arrayPrototypeReduceRightCode;
extern const int s_arrayPrototypeReduceRightCodeLength;
extern const ConstructAbility s_arrayPrototypeReduceRightCodeConstructAbility;
extern const char* s_arrayPrototypeEveryCode;
extern const int s_arrayPrototypeEveryCodeLength;
extern const ConstructAbility s_arrayPrototypeEveryCodeConstructAbility;
extern const char* s_arrayPrototypeForEachCode;
extern const int s_arrayPrototypeForEachCodeLength;
extern const ConstructAbility s_arrayPrototypeForEachCodeConstructAbility;
extern const char* s_arrayPrototypeFilterCode;
extern const int s_arrayPrototypeFilterCodeLength;
extern const ConstructAbility s_arrayPrototypeFilterCodeConstructAbility;
extern const char* s_arrayPrototypeMapCode;
extern const int s_arrayPrototypeMapCodeLength;
extern const ConstructAbility s_arrayPrototypeMapCodeConstructAbility;
extern const char* s_arrayPrototypeSomeCode;
extern const int s_arrayPrototypeSomeCodeLength;
extern const ConstructAbility s_arrayPrototypeSomeCodeConstructAbility;
extern const char* s_arrayPrototypeFillCode;
extern const int s_arrayPrototypeFillCodeLength;
extern const ConstructAbility s_arrayPrototypeFillCodeConstructAbility;
extern const char* s_arrayPrototypeFindCode;
extern const int s_arrayPrototypeFindCodeLength;
extern const ConstructAbility s_arrayPrototypeFindCodeConstructAbility;
extern const char* s_arrayPrototypeFindIndexCode;
extern const int s_arrayPrototypeFindIndexCodeLength;
extern const ConstructAbility s_arrayPrototypeFindIndexCodeConstructAbility;
extern const char* s_arrayPrototypeIncludesCode;
extern const int s_arrayPrototypeIncludesCodeLength;
extern const ConstructAbility s_arrayPrototypeIncludesCodeConstructAbility;
extern const char* s_arrayPrototypeSortCode;
extern const int s_arrayPrototypeSortCodeLength;
extern const ConstructAbility s_arrayPrototypeSortCodeConstructAbility;
extern const char* s_arrayPrototypeCopyWithinCode;
extern const int s_arrayPrototypeCopyWithinCodeLength;
extern const ConstructAbility s_arrayPrototypeCopyWithinCodeConstructAbility;

#define JSC_FOREACH_ARRAY_PROTOTYPE_BUILTIN(macro) \
    macro(reduce, ArrayPrototypeReduce, 1) \
    macro(reduceRight, ArrayPrototypeReduceRight, 1) \
    macro(every, ArrayPrototypeEvery, 1) \
    macro(forEach, ArrayPrototypeForEach, 1) \
    macro(filter, ArrayPrototypeFilter, 1) \
    macro(map, ArrayPrototypeMap, 1) \
    macro(some, ArrayPrototypeSome, 1) \
    macro(fill, ArrayPrototypeFill, 1) \
    macro(find, ArrayPrototypeFind, 1) \
    macro(findIndex, ArrayPrototypeFindIndex, 1) \
    macro(includes, ArrayPrototypeIncludes, 1) \
    macro(sort, ArrayPrototypeSort, 1) \
    macro(copyWithin, ArrayPrototypeCopyWithin, 2) \

#define JSC_BUILTIN_ARRAYPROTOTYPEREDUCE 1
#define JSC_BUILTIN_ARRAYPROTOTYPEREDUCERIGHT 1
#define JSC_BUILTIN_ARRAYPROTOTYPEEVERY 1
#define JSC_BUILTIN_ARRAYPROTOTYPEFOREACH 1
#define JSC_BUILTIN_ARRAYPROTOTYPEFILTER 1
#define JSC_BUILTIN_ARRAYPROTOTYPEMAP 1
#define JSC_BUILTIN_ARRAYPROTOTYPESOME 1
#define JSC_BUILTIN_ARRAYPROTOTYPEFILL 1
#define JSC_BUILTIN_ARRAYPROTOTYPEFIND 1
#define JSC_BUILTIN_ARRAYPROTOTYPEFINDINDEX 1
#define JSC_BUILTIN_ARRAYPROTOTYPEINCLUDES 1
#define JSC_BUILTIN_ARRAYPROTOTYPESORT 1
#define JSC_BUILTIN_ARRAYPROTOTYPECOPYWITHIN 1


/* ArrayConstructor functions */
extern const char* s_arrayConstructorOfCode;
extern const int s_arrayConstructorOfCodeLength;
extern const ConstructAbility s_arrayConstructorOfCodeConstructAbility;
extern const char* s_arrayConstructorFromCode;
extern const int s_arrayConstructorFromCodeLength;
extern const ConstructAbility s_arrayConstructorFromCodeConstructAbility;

#define JSC_FOREACH_ARRAYCONSTRUCTOR_BUILTIN(macro) \
    macro(of, ArrayConstructorOf, 0) \
    macro(from, ArrayConstructorFrom, 1) \

#define JSC_BUILTIN_ARRAYCONSTRUCTOROF 1
#define JSC_BUILTIN_ARRAYCONSTRUCTORFROM 1


/* ArrayIterator.prototype functions */
extern const char* s_arrayIteratorPrototypeNextCode;
extern const int s_arrayIteratorPrototypeNextCodeLength;
extern const ConstructAbility s_arrayIteratorPrototypeNextCodeConstructAbility;

#define JSC_FOREACH_ARRAYITERATOR_PROTOTYPE_BUILTIN(macro) \
    macro(next, ArrayIteratorPrototypeNext, 0) \

#define JSC_BUILTIN_ARRAYITERATORPROTOTYPENEXT 1


/* Function.prototype functions */
extern const char* s_functionPrototypeCallCode;
extern const int s_functionPrototypeCallCodeLength;
extern const ConstructAbility s_functionPrototypeCallCodeConstructAbility;
extern const char* s_functionPrototypeApplyCode;
extern const int s_functionPrototypeApplyCodeLength;
extern const ConstructAbility s_functionPrototypeApplyCodeConstructAbility;

#define JSC_FOREACH_FUNCTION_PROTOTYPE_BUILTIN(macro) \
    macro(call, FunctionPrototypeCall, 1) \
    macro(apply, FunctionPrototypeApply, 2) \

#define JSC_BUILTIN_FUNCTIONPROTOTYPECALL 1
#define JSC_BUILTIN_FUNCTIONPROTOTYPEAPPLY 1


/* GlobalObject functions */
extern const char* s_globalObjectToIntegerCode;
extern const int s_globalObjectToIntegerCodeLength;
extern const ConstructAbility s_globalObjectToIntegerCodeConstructAbility;
extern const char* s_globalObjectToLengthCode;
extern const int s_globalObjectToLengthCodeLength;
extern const ConstructAbility s_globalObjectToLengthCodeConstructAbility;
extern const char* s_globalObjectIsObjectCode;
extern const int s_globalObjectIsObjectCodeLength;
extern const ConstructAbility s_globalObjectIsObjectCodeConstructAbility;

#define JSC_FOREACH_GLOBALOBJECT_BUILTIN(macro) \
    macro(toInteger, GlobalObjectToInteger, 1) \
    macro(toLength, GlobalObjectToLength, 1) \
    macro(isObject, GlobalObjectIsObject, 1) \

#define JSC_BUILTIN_GLOBALOBJECTTOINTEGER 1
#define JSC_BUILTIN_GLOBALOBJECTTOLENGTH 1
#define JSC_BUILTIN_GLOBALOBJECTISOBJECT 1


/* InspectorInstrumentationObject functions */
extern const char* s_inspectorInstrumentationObjectPromiseFulfilledCode;
extern const int s_inspectorInstrumentationObjectPromiseFulfilledCodeLength;
extern const ConstructAbility s_inspectorInstrumentationObjectPromiseFulfilledCodeConstructAbility;
extern const char* s_inspectorInstrumentationObjectPromiseRejectedCode;
extern const int s_inspectorInstrumentationObjectPromiseRejectedCodeLength;
extern const ConstructAbility s_inspectorInstrumentationObjectPromiseRejectedCodeConstructAbility;

#define JSC_FOREACH_INSPECTORINSTRUMENTATIONOBJECT_BUILTIN(macro) \
    macro(promiseFulfilled, InspectorInstrumentationObjectPromiseFulfilled, 3) \
    macro(promiseRejected, InspectorInstrumentationObjectPromiseRejected, 3) \

#define JSC_BUILTIN_INSPECTORINSTRUMENTATIONOBJECTPROMISEFULFILLED 1
#define JSC_BUILTIN_INSPECTORINSTRUMENTATIONOBJECTPROMISEREJECTED 1


/* Iterator.prototype functions */
extern const char* s_iteratorPrototypeSymbolIteratorCode;
extern const int s_iteratorPrototypeSymbolIteratorCodeLength;
extern const ConstructAbility s_iteratorPrototypeSymbolIteratorCodeConstructAbility;

#define JSC_FOREACH_ITERATOR_PROTOTYPE_BUILTIN(macro) \
    macro(symbolIterator, IteratorPrototypeSymbolIterator, 0) \

#define JSC_BUILTIN_ITERATORPROTOTYPESYMBOLITERATOR 1


/* ObjectConstructor functions */
extern const char* s_objectConstructorAssignCode;
extern const int s_objectConstructorAssignCodeLength;
extern const ConstructAbility s_objectConstructorAssignCodeConstructAbility;

#define JSC_FOREACH_OBJECTCONSTRUCTOR_BUILTIN(macro) \
    macro(assign, ObjectConstructorAssign, 2) \

#define JSC_BUILTIN_OBJECTCONSTRUCTORASSIGN 1


/* Operations.Promise functions */
extern const char* s_operationsPromiseIsPromiseCode;
extern const int s_operationsPromiseIsPromiseCodeLength;
extern const ConstructAbility s_operationsPromiseIsPromiseCodeConstructAbility;
extern const char* s_operationsPromiseNewPromiseReactionCode;
extern const int s_operationsPromiseNewPromiseReactionCodeLength;
extern const ConstructAbility s_operationsPromiseNewPromiseReactionCodeConstructAbility;
extern const char* s_operationsPromiseNewPromiseDeferredCode;
extern const int s_operationsPromiseNewPromiseDeferredCodeLength;
extern const ConstructAbility s_operationsPromiseNewPromiseDeferredCodeConstructAbility;
extern const char* s_operationsPromiseNewPromiseCapabilityCode;
extern const int s_operationsPromiseNewPromiseCapabilityCodeLength;
extern const ConstructAbility s_operationsPromiseNewPromiseCapabilityCodeConstructAbility;
extern const char* s_operationsPromiseTriggerPromiseReactionsCode;
extern const int s_operationsPromiseTriggerPromiseReactionsCodeLength;
extern const ConstructAbility s_operationsPromiseTriggerPromiseReactionsCodeConstructAbility;
extern const char* s_operationsPromiseRejectPromiseCode;
extern const int s_operationsPromiseRejectPromiseCodeLength;
extern const ConstructAbility s_operationsPromiseRejectPromiseCodeConstructAbility;
extern const char* s_operationsPromiseFulfillPromiseCode;
extern const int s_operationsPromiseFulfillPromiseCodeLength;
extern const ConstructAbility s_operationsPromiseFulfillPromiseCodeConstructAbility;
extern const char* s_operationsPromiseCreateResolvingFunctionsCode;
extern const int s_operationsPromiseCreateResolvingFunctionsCodeLength;
extern const ConstructAbility s_operationsPromiseCreateResolvingFunctionsCodeConstructAbility;
extern const char* s_operationsPromisePromiseReactionJobCode;
extern const int s_operationsPromisePromiseReactionJobCodeLength;
extern const ConstructAbility s_operationsPromisePromiseReactionJobCodeConstructAbility;
extern const char* s_operationsPromisePromiseResolveThenableJobCode;
extern const int s_operationsPromisePromiseResolveThenableJobCodeLength;
extern const ConstructAbility s_operationsPromisePromiseResolveThenableJobCodeConstructAbility;
extern const char* s_operationsPromiseInitializePromiseCode;
extern const int s_operationsPromiseInitializePromiseCodeLength;
extern const ConstructAbility s_operationsPromiseInitializePromiseCodeConstructAbility;

#define JSC_FOREACH_OPERATIONS_PROMISE_BUILTIN(macro) \
    macro(isPromise, OperationsPromiseIsPromise, 1) \
    macro(newPromiseReaction, OperationsPromiseNewPromiseReaction, 2) \
    macro(newPromiseDeferred, OperationsPromiseNewPromiseDeferred, 0) \
    macro(newPromiseCapability, OperationsPromiseNewPromiseCapability, 1) \
    macro(triggerPromiseReactions, OperationsPromiseTriggerPromiseReactions, 2) \
    macro(rejectPromise, OperationsPromiseRejectPromise, 2) \
    macro(fulfillPromise, OperationsPromiseFulfillPromise, 2) \
    macro(createResolvingFunctions, OperationsPromiseCreateResolvingFunctions, 1) \
    macro(promiseReactionJob, OperationsPromisePromiseReactionJob, 2) \
    macro(promiseResolveThenableJob, OperationsPromisePromiseResolveThenableJob, 3) \
    macro(initializePromise, OperationsPromiseInitializePromise, 1) \

#define JSC_BUILTIN_OPERATIONSPROMISEISPROMISE 1
#define JSC_BUILTIN_OPERATIONSPROMISENEWPROMISEREACTION 1
#define JSC_BUILTIN_OPERATIONSPROMISENEWPROMISEDEFERRED 1
#define JSC_BUILTIN_OPERATIONSPROMISENEWPROMISECAPABILITY 1
#define JSC_BUILTIN_OPERATIONSPROMISETRIGGERPROMISEREACTIONS 1
#define JSC_BUILTIN_OPERATIONSPROMISEREJECTPROMISE 1
#define JSC_BUILTIN_OPERATIONSPROMISEFULFILLPROMISE 1
#define JSC_BUILTIN_OPERATIONSPROMISECREATERESOLVINGFUNCTIONS 1
#define JSC_BUILTIN_OPERATIONSPROMISEPROMISEREACTIONJOB 1
#define JSC_BUILTIN_OPERATIONSPROMISEPROMISERESOLVETHENABLEJOB 1
#define JSC_BUILTIN_OPERATIONSPROMISEINITIALIZEPROMISE 1


/* Promise.prototype functions */
extern const char* s_promisePrototypeCatchCode;
extern const int s_promisePrototypeCatchCodeLength;
extern const ConstructAbility s_promisePrototypeCatchCodeConstructAbility;
extern const char* s_promisePrototypeThenCode;
extern const int s_promisePrototypeThenCodeLength;
extern const ConstructAbility s_promisePrototypeThenCodeConstructAbility;

#define JSC_FOREACH_PROMISE_PROTOTYPE_BUILTIN(macro) \
    macro(catch, PromisePrototypeCatch, 1) \
    macro(then, PromisePrototypeThen, 2) \

#define JSC_BUILTIN_PROMISEPROTOTYPECATCH 1
#define JSC_BUILTIN_PROMISEPROTOTYPETHEN 1


/* PromiseConstructor functions */
extern const char* s_promiseConstructorAllCode;
extern const int s_promiseConstructorAllCodeLength;
extern const ConstructAbility s_promiseConstructorAllCodeConstructAbility;
extern const char* s_promiseConstructorRaceCode;
extern const int s_promiseConstructorRaceCodeLength;
extern const ConstructAbility s_promiseConstructorRaceCodeConstructAbility;
extern const char* s_promiseConstructorRejectCode;
extern const int s_promiseConstructorRejectCodeLength;
extern const ConstructAbility s_promiseConstructorRejectCodeConstructAbility;
extern const char* s_promiseConstructorResolveCode;
extern const int s_promiseConstructorResolveCodeLength;
extern const ConstructAbility s_promiseConstructorResolveCodeConstructAbility;

#define JSC_FOREACH_PROMISECONSTRUCTOR_BUILTIN(macro) \
    macro(all, PromiseConstructorAll, 1) \
    macro(race, PromiseConstructorRace, 1) \
    macro(reject, PromiseConstructorReject, 1) \
    macro(resolve, PromiseConstructorResolve, 1) \

#define JSC_BUILTIN_PROMISECONSTRUCTORALL 1
#define JSC_BUILTIN_PROMISECONSTRUCTORRACE 1
#define JSC_BUILTIN_PROMISECONSTRUCTORREJECT 1
#define JSC_BUILTIN_PROMISECONSTRUCTORRESOLVE 1


/* ReflectObject functions */
extern const char* s_reflectObjectApplyCode;
extern const int s_reflectObjectApplyCodeLength;
extern const ConstructAbility s_reflectObjectApplyCodeConstructAbility;
extern const char* s_reflectObjectDeletePropertyCode;
extern const int s_reflectObjectDeletePropertyCodeLength;
extern const ConstructAbility s_reflectObjectDeletePropertyCodeConstructAbility;
extern const char* s_reflectObjectHasCode;
extern const int s_reflectObjectHasCodeLength;
extern const ConstructAbility s_reflectObjectHasCodeConstructAbility;

#define JSC_FOREACH_REFLECTOBJECT_BUILTIN(macro) \
    macro(apply, ReflectObjectApply, 3) \
    macro(deleteProperty, ReflectObjectDeleteProperty, 2) \
    macro(has, ReflectObjectHas, 2) \

#define JSC_BUILTIN_REFLECTOBJECTAPPLY 1
#define JSC_BUILTIN_REFLECTOBJECTDELETEPROPERTY 1
#define JSC_BUILTIN_REFLECTOBJECTHAS 1


/* StringConstructor functions */
extern const char* s_stringConstructorRawCode;
extern const int s_stringConstructorRawCodeLength;
extern const ConstructAbility s_stringConstructorRawCodeConstructAbility;

#define JSC_FOREACH_STRINGCONSTRUCTOR_BUILTIN(macro) \
    macro(raw, StringConstructorRaw, 1) \

#define JSC_BUILTIN_STRINGCONSTRUCTORRAW 1


/* StringIterator.prototype functions */
extern const char* s_stringIteratorPrototypeNextCode;
extern const int s_stringIteratorPrototypeNextCodeLength;
extern const ConstructAbility s_stringIteratorPrototypeNextCodeConstructAbility;

#define JSC_FOREACH_STRINGITERATOR_PROTOTYPE_BUILTIN(macro) \
    macro(next, StringIteratorPrototypeNext, 0) \

#define JSC_BUILTIN_STRINGITERATORPROTOTYPENEXT 1


#define JSC_FOREACH_BUILTIN(macro)\
    macro(arrayPrototypeReduceCode, reduce, s_arrayPrototypeReduceCodeLength) \
    macro(arrayPrototypeReduceRightCode, reduceRight, s_arrayPrototypeReduceRightCodeLength) \
    macro(arrayPrototypeEveryCode, every, s_arrayPrototypeEveryCodeLength) \
    macro(arrayPrototypeForEachCode, forEach, s_arrayPrototypeForEachCodeLength) \
    macro(arrayPrototypeFilterCode, filter, s_arrayPrototypeFilterCodeLength) \
    macro(arrayPrototypeMapCode, map, s_arrayPrototypeMapCodeLength) \
    macro(arrayPrototypeSomeCode, some, s_arrayPrototypeSomeCodeLength) \
    macro(arrayPrototypeFillCode, fill, s_arrayPrototypeFillCodeLength) \
    macro(arrayPrototypeFindCode, find, s_arrayPrototypeFindCodeLength) \
    macro(arrayPrototypeFindIndexCode, findIndex, s_arrayPrototypeFindIndexCodeLength) \
    macro(arrayPrototypeIncludesCode, includes, s_arrayPrototypeIncludesCodeLength) \
    macro(arrayPrototypeSortCode, sort, s_arrayPrototypeSortCodeLength) \
    macro(arrayPrototypeCopyWithinCode, copyWithin, s_arrayPrototypeCopyWithinCodeLength) \
    macro(arrayConstructorOfCode, of, s_arrayConstructorOfCodeLength) \
    macro(arrayConstructorFromCode, from, s_arrayConstructorFromCodeLength) \
    macro(arrayIteratorPrototypeNextCode, next, s_arrayIteratorPrototypeNextCodeLength) \
    macro(functionPrototypeCallCode, call, s_functionPrototypeCallCodeLength) \
    macro(functionPrototypeApplyCode, apply, s_functionPrototypeApplyCodeLength) \
    macro(globalObjectToIntegerCode, toInteger, s_globalObjectToIntegerCodeLength) \
    macro(globalObjectToLengthCode, toLength, s_globalObjectToLengthCodeLength) \
    macro(globalObjectIsObjectCode, isObject, s_globalObjectIsObjectCodeLength) \
    macro(inspectorInstrumentationObjectPromiseFulfilledCode, promiseFulfilled, s_inspectorInstrumentationObjectPromiseFulfilledCodeLength) \
    macro(inspectorInstrumentationObjectPromiseRejectedCode, promiseRejected, s_inspectorInstrumentationObjectPromiseRejectedCodeLength) \
    macro(iteratorPrototypeSymbolIteratorCode, symbolIterator, s_iteratorPrototypeSymbolIteratorCodeLength) \
    macro(objectConstructorAssignCode, assign, s_objectConstructorAssignCodeLength) \
    macro(operationsPromiseIsPromiseCode, isPromise, s_operationsPromiseIsPromiseCodeLength) \
    macro(operationsPromiseNewPromiseReactionCode, newPromiseReaction, s_operationsPromiseNewPromiseReactionCodeLength) \
    macro(operationsPromiseNewPromiseDeferredCode, newPromiseDeferred, s_operationsPromiseNewPromiseDeferredCodeLength) \
    macro(operationsPromiseNewPromiseCapabilityCode, newPromiseCapability, s_operationsPromiseNewPromiseCapabilityCodeLength) \
    macro(operationsPromiseTriggerPromiseReactionsCode, triggerPromiseReactions, s_operationsPromiseTriggerPromiseReactionsCodeLength) \
    macro(operationsPromiseRejectPromiseCode, rejectPromise, s_operationsPromiseRejectPromiseCodeLength) \
    macro(operationsPromiseFulfillPromiseCode, fulfillPromise, s_operationsPromiseFulfillPromiseCodeLength) \
    macro(operationsPromiseCreateResolvingFunctionsCode, createResolvingFunctions, s_operationsPromiseCreateResolvingFunctionsCodeLength) \
    macro(operationsPromisePromiseReactionJobCode, promiseReactionJob, s_operationsPromisePromiseReactionJobCodeLength) \
    macro(operationsPromisePromiseResolveThenableJobCode, promiseResolveThenableJob, s_operationsPromisePromiseResolveThenableJobCodeLength) \
    macro(operationsPromiseInitializePromiseCode, initializePromise, s_operationsPromiseInitializePromiseCodeLength) \
    macro(promisePrototypeCatchCode, catch, s_promisePrototypeCatchCodeLength) \
    macro(promisePrototypeThenCode, then, s_promisePrototypeThenCodeLength) \
    macro(promiseConstructorAllCode, all, s_promiseConstructorAllCodeLength) \
    macro(promiseConstructorRaceCode, race, s_promiseConstructorRaceCodeLength) \
    macro(promiseConstructorRejectCode, reject, s_promiseConstructorRejectCodeLength) \
    macro(promiseConstructorResolveCode, resolve, s_promiseConstructorResolveCodeLength) \
    macro(reflectObjectApplyCode, apply, s_reflectObjectApplyCodeLength) \
    macro(reflectObjectDeletePropertyCode, deleteProperty, s_reflectObjectDeletePropertyCodeLength) \
    macro(reflectObjectHasCode, has, s_reflectObjectHasCodeLength) \
    macro(stringConstructorRawCode, raw, s_stringConstructorRawCodeLength) \
    macro(stringIteratorPrototypeNextCode, next, s_stringIteratorPrototypeNextCodeLength) \


#define JSC_FOREACH_BUILTIN_FUNCTION_NAME(macro) \
    macro(all) \
    macro(apply) \
    macro(assign) \
    macro(call) \
    macro(catch) \
    macro(copyWithin) \
    macro(createResolvingFunctions) \
    macro(deleteProperty) \
    macro(every) \
    macro(fill) \
    macro(filter) \
    macro(find) \
    macro(findIndex) \
    macro(forEach) \
    macro(from) \
    macro(fulfillPromise) \
    macro(has) \
    macro(includes) \
    macro(initializePromise) \
    macro(isObject) \
    macro(isPromise) \
    macro(map) \
    macro(newPromiseCapability) \
    macro(newPromiseDeferred) \
    macro(newPromiseReaction) \
    macro(next) \
    macro(of) \
    macro(promiseFulfilled) \
    macro(promiseReactionJob) \
    macro(promiseRejected) \
    macro(promiseResolveThenableJob) \
    macro(race) \
    macro(raw) \
    macro(reduce) \
    macro(reduceRight) \
    macro(reject) \
    macro(rejectPromise) \
    macro(resolve) \
    macro(some) \
    macro(sort) \
    macro(symbolIterator) \
    macro(then) \
    macro(toInteger) \
    macro(toLength) \
    macro(triggerPromiseReactions) \


#define JSC_DECLARE_BUILTIN_GENERATOR(codeName, functionName, argumentCount) \
    FunctionExecutable* codeName##Generator(VM&);

JSC_FOREACH_BUILTIN(JSC_DECLARE_BUILTIN_GENERATOR)
#undef JSC_DECLARE_BUILTIN_GENERATOR

#define JSC_BUILTIN_EXISTS(name) defined JSC_BUILTIN_ ## name

}

#endif

